(function ($, Drupal, drupalSettings) {

  Drupal.behaviors.mapbox_gl = {

    attach: function (context, settings) {

      // can access setting from 'drupalSettings';
      var accessToken = drupalSettings.mapBoxBlock.accessToken;
      var style = drupalSettings.mapBoxBlock.style;
      var center_altitude = drupalSettings.mapBoxBlock.center.altitude;
      var center_latitude = drupalSettings.mapBoxBlock.center.latitude;
      var marker_altitude = drupalSettings.mapBoxBlock.marker.marker_altitude;
      var marker_latitude = drupalSettings.mapBoxBlock.marker.marker_latitude;
      var popup_texte = drupalSettings.mapBoxBlock.popup_texte;
      var zoom = drupalSettings.mapBoxBlock.zoom;
      var navigationcontrol = drupalSettings.mapBoxBlock.navigationcontrol;

      mapboxgl.accessToken = accessToken;
      var mapgl = new mapboxgl.Map({
        container: 'mapgl', // container id
        style: style,
        center: [center_altitude, center_latitude], // starting position
        zoom: zoom // starting zoom
      });

      // create the popup
      var popup = new mapboxgl.Popup({ offset: 25 })
      .setText(popup_texte);

      var marker = new mapboxgl.Marker({
        draggable: false
      })
        .setLngLat([marker_altitude, marker_latitude])
        .setPopup(popup) // sets a popup on this marker
        .addTo(mapgl);

      if (navigationcontrol == true) {
        // Add zoom and rotation controls to the map.
        mapgl.addControl(new mapboxgl.NavigationControl());
      }

    }
  };

})(jQuery, Drupal, drupalSettings);
